from django.conf.urls import patterns, include, url
from django.contrib import admin
from django.conf import settings

admin.autodiscover()

urlpatterns = patterns('',
    #Main
    url(r'^$', 'other.views.main'),

    #App
    url(r'^app/$', 'app.views.app'),
    url(r'^register_graphic/$', 'app.views.register_graphic'),
    #Load file (choose file, delete file, add file)
    url(r'^select_file/$','app.views.select_file'),
    url(r'^delete_file/$','app.views.delete_file'),
    url(r'^upload_file/$','app.views.upload_file'),
    url(r'^process_data/$','app.views.process_data'),
    #Show info
    url(r'^show_info/$','app.views.show_info'),
    url(r'^edit_info/$','app.views.edit_info'),
    #General
    url(r'^set_general/$','app.views.set_general'),
    #Statistical analysis
    url(r'^stat_graphic/$','app.views.stat_graphic'),
    #Sleep analysis
    url(r'^sleep_graphic/$','app.views.sleep_graphic'),
    #Cosinor_analysis
    url(r'^cosinor_graphic/$','app.views.cosinor_graphic'),
    #Symbolic analysis
    url(r'^symbol_graphic/$','app.views.symbol_graphic'),
    #ctm
    url(r'^ctm_graphic/$','app.views.ctm_graphic'),
    #Classifier
    url(r'^classifier_graphic/$','app.views.classifier_graphic'),

    #Download Results
    url(r'^download_results/$','download_results.views.download_results'),
    url(r'^generate_results/$','download_results.views.generate_results'),
    url(r'^get_results/$','download_results.views.get_results'),

    #Contact
    url(r'^contact/$','contact.views.contact'),

    #static and other
    url(r'^static/(?P<path>.*)$', 'django.views.static.serve', {'document_root': settings.STATIC_ROOT, 'show_indexes': settings.DEBUG}),
    url(r'^loading_1/$','other.views.loading_1'),
    url(r'^loading_2/$','other.views.loading_2'),
    url(r'^uploading_file/$','other.views.uploading_file'),
    url(r'^processing_data/$','other.views.processing_data'),

    #log
    url(r'^log_in/$',  'log_in_out.views.to_log_in'),
    url(r'^log_out/$', 'log_in_out.views.to_log_out'),

    #Admin
    url(r'^admin/', include(admin.site.urls)),

)
