from django.db import models
from django.contrib.auth.models import User

#show tables -> python manage.py sqlall app

#######################
#      FILE DATA      #
#######################
class file_data(models.Model):
	user_name        = models.ForeignKey(User)
	file_name        = models.CharField(max_length=200)
	upload_date      = models.DateTimeField('upload date',auto_now=True)
	start_time       = models.CharField(max_length=100,blank = True, null=True)
	start_date       = models.CharField(max_length=100,blank = True, null=True)
	epoch_period     = models.CharField(max_length=100,blank = True, null=True)
	mode             = models.IntegerField(blank = True)
	descriptive_name = models.CharField(max_length=200)
	notes            = models.CharField(max_length=1000,blank = True, null=True)
	n_channels       = models.IntegerField(blank = True,null=True)
	channels_name    = models.CharField(max_length=100,blank = True, null=True)
	total_t          = models.CharField(max_length=100,blank = True, null=True)
	data_per_channel = models.IntegerField(blank = True)
	a_r_start        = models.CharField(max_length=100,blank = True, null=True)
	a_r_end          = models.CharField(max_length=100,blank = True, null=True)
	interval_end     = models.CharField(max_length=100,blank = True, null=True)
	def __unicode__(self):
		return self.descriptive_name

class file_header(models.Model):
	regarding   = models.ForeignKey(file_data, unique=True)
	header      = models.TextField(blank = True, null=True)
	def __unicode__(self):
		return unicode(self.regarding)

class file_channel(models.Model):
	regarding = models.ForeignKey(file_data)
	number    = models.IntegerField(blank = True)
	channel      = models.TextField(blank = True, null=True)
	def __unicode__(self):
		return unicode(self.regarding)

class file_mask(models.Model):
	regarding = models.ForeignKey(file_data, unique=True)
	mask      = models.TextField(blank = True, null=True)
	def __unicode__(self):
		return unicode(self.regarding)

##########################
#      SESSION DATA      #
##########################
class session_data(models.Model):
	user_name    = models.ForeignKey(User,unique=True)
	session_key  = models.TextField()
	file_dat     = models.ForeignKey(file_data,
		blank      = True,
		null       = True,
		on_delete  = models.SET_NULL)
	channel      = models.IntegerField(blank = True,default=0)
	channel_name = models.CharField(max_length=200,blank = True, null=True)
	decim        = models.IntegerField(blank = True,default=1)
	onset        = models.CharField(max_length=100,blank = True, null=True)
	end          = models.CharField(max_length=100,blank = True, null=True)
	#a_r_start    = models.CharField(max_length=100,blank = True, null=True)
	#a_r_end      = models.CharField(max_length=100,blank = True, null=True)
	def __unicode__(self):
   		return unicode(self.user_name)

class session_channel_mask(models.Model):
	regarding  = models.ForeignKey(session_data, unique=True)
	channel    = models.TextField(blank = True, null=True)
	mask       = models.TextField(blank = True, null=True)
	def __unicode__(self):
		return unicode(self.regarding)