# -*- coding: utf-8 -*-
"""
Created on Wen May 14 ‏‎09:57:24 2014

@author: Daniel Treceño

"""
import numpy

def ctm_fun(channel, mask,frame, rho):
    channel = numpy.asarray(channel,dtype=float)
    mask = numpy.asarray(mask,dtype=float)
    mask = mask.astype(bool)
    
    if frame == 1: #actividad
        data = channel[mask]
    elif frame == 2: #descanso
        data = channel[mask==0]
    elif frame == 3: #completo
        data = channel
    else:
        #data = channel
        return -1

    x1 = data[0:-2]
    x2 = data[1:-1]
    x3 = data[2:]

    d1 = x1 - x2
    d2 = x2 - x3

    d1_2 = numpy.power(d1,2)
    d2_2 = numpy.power(d2,2)

    sd = numpy.add(d1_2, d2_2)

    radios = numpy.sqrt(sd)
    MR = numpy.maximum(rho,numpy.max(radios))

    LPD = numpy.array(len(radios[radios <= rho]), dtype=float)
    LR = numpy.array(len(radios), dtype=float)

    maxi = numpy.maximum(numpy.max(numpy.absolute(d1)),numpy.max(numpy.absolute(d2)))
    maxi = numpy.maximum(maxi, rho)

    valorctm = numpy.divide(LPD, LR)
    out = {'X':d1.tolist(),
        'Y':d2.tolist(),
        'MR':MR,
        'CTM':numpy.round(valorctm,4),
        'maxi':maxi,
        'rho':rho}
    return out