# -*- coding: utf-8 -*-
"""
Created on Mon May 12 12:18:11 2014

@author: dani
"""

import numpy
from scipy.ndimage.measurements import label

def sleep_analysis_def (frame):
    #ya tengo el intervalo bien definido, sólo necesito hacer el análisis
    frame = numpy.asarray(frame,dtype=float)
    H = numpy.ones(60,dtype=float)
    x = numpy.convolve(frame,H,mode='same')
    x = x[::60]
    K = 2.54
    x = K*x
    #    
    NZW = numpy.zeros(x.__len__()-5)
    NTL = numpy.zeros(x.__len__()-5)
    NTH = numpy.zeros(x.__len__()-5)
    S5 = numpy.zeros(x.__len__()-5)
    ML = numpy.zeros(x.__len__()-5)
    LW4 = numpy.zeros(x.__len__()-5)
    #    
    for k in range(5,x.__len__()-5):
        w55 = x[k-5:k+6]
        w50 = x[k-5:k+1]
        w10 = x[k-1:k+1]
        w04 = x[k:k+5]
                
        NZW[k] = sum(w55 == 0);
        NTL[k] = sum(w55 < 100);
        NTH[k] = sum(w55 >= 100);
        S5[k] = numpy.std(w50,ddof=1);
        ML[k] = numpy.mean(w10);
        LW4[K] = min(w04);
    
    X = numpy.array([15.94, 3.223, 2.138, 1.1036, 0.466, 0.00292, 0.0106,
                     5.134, 1.696, 2.062, 0.9568, 0.0585, 0.00556, 0.0105,
                    -25.638, 1.714, 3.0168, 4.064, 0.1066, 0.386, 0.016]).reshape((3,7)) 
    aux = numpy.ones((7,NZW.__len__()))
    aux[1,:] = NZW
    aux[2,:] = NTL
    aux[3,:] = NTH
    aux[4,:] = S5
    aux[5,:] = ML
    aux[6,:] = LW4
       
    P = numpy.dot(X,aux)
     
    PQS = P[0]
    PAS = P[1]
    PAW = P[2]
    
    PS = ((PQS >= PAW) | (PAS >= PAW))
    PD = (PS == False)
    PSchar = PS.astype(int).tolist().__str__()
    PSchar = PSchar.replace(",","")
    PSchar = PSchar.replace(" ","")
    PSchar = PSchar.replace("[","")
    PSchar = PSchar.replace("]","")
    
    SleepOnset = numpy.min(numpy.where(PS==1))+6
    TotalSleepTime = sum(PS)
    WakeAfterSleepOnset = sum(PS[SleepOnset-5:] == 0)
    Aux = []
    for i in range(0,PSchar.__len__()-1):
        c = PSchar[i:i+2]
        if c == '01':
            Aux.append(i)
    Awakenings = Aux.__len__()
    #AverageAwakening = WakeAfterSleepOnset./(Awakenings+0.0000001)
    AverageAwakening = WakeAfterSleepOnset/(Awakenings+0.0000001)
    TotalCounts = sum(x)
    Efficiency = TotalSleepTime/(float(PS.__len__()) + 10.)*100
    #    
    SuenosDentroPPal, num_features = label(PS)
    D = numpy.zeros(max(SuenosDentroPPal))
    for k in range(0,max(SuenosDentroPPal)):
        D[k] = sum(SuenosDentroPPal == (k+1))
    #    
    LongestSleepInterval=max(D)
    PercentQuiteSleep=sum((PQS[PS])>=(PAS[PS]))/float(PS.__len__())*100
    #    
    out = {'algorithm': 'Metodo de Sadeh-Acebo',
           'SleepOnset': SleepOnset,
           'TotalSleepTime': TotalSleepTime,
           'WakeAfterSleepOnset': WakeAfterSleepOnset,
           'Awakenings': Awakenings,
           'AverageAwakening': numpy.round(AverageAwakening,4),
           'TotalCounts': numpy.round(TotalCounts,4),
           'Efficiency': numpy.round(Efficiency,4),
           'LSInterval': numpy.round(LongestSleepInterval,4),
           'PQSleep': numpy.round(PercentQuiteSleep,4)}
    return out