# -*- coding: utf-8 -*-
"""
Created on Tue May 20 09:18:53 2014

@author: dani
"""

import numpy as np
import string
from scipy.stats import scoreatpercentile

def int2base(x, base, size=None, order='decreasing'):
    x = np.asarray(x)
    if size is None:
        size = int(np.ceil(np.log(np.max(x))/np.log(base)))
    if order == "decreasing":
        powers = base ** np.arange(size - 1, -1, -1)
    else:
        powers = base ** np.arange(size)
    digits = (x.reshape(x.shape + (1,)) // powers) % base
    alphanum = string.digits + string.ascii_lowercase
    nums = alphanum[:base]
    word = ''
    for k in digits:
        word += nums[k]  
    return digits, word

#overlaping está al revés que en matlab, aquí es WL-OL el avance, en matlab es OL
# AL -> AlphabeLength
# WL -> WordLength
# OL -> Overlaping
# matlab -> Cuando es igual a 1 fuerza a que lo sresultados sean como los de matlab
def DinSym(channel,mask,frame, AL, WL, OL, matlab):
    channel = np.asarray(channel,dtype=float)
    mask = np.asarray(mask,dtype=float)
    mask = mask.astype(bool)
    
    if frame == 1: #actividad
        datos = channel[mask]
    elif frame == 2: #descanso
        datos = channel[mask==0]
    elif frame == 3: #completo
        datos = channel
    else:
        #data = channel
        return -1
    #Dictionary creation
    Dictionary = []
    DictLengh = np.power(AL,WL)
    for k in range(0, DictLengh):
        digits, word = int2base(k,AL,WL)
        Dictionary.append(word)
    
    #Signal quantification
    q = np.array(100./AL, dtype=float)
    v = np.linspace(0, AL, AL+1)
    v = np.array(v, dtype=float)
    Percentiles = np.array(q * v, dtype=float)
    #print Percentiles

    ValPercentiles = np.array(Percentiles, dtype=float)
    for k in range(0, len(Percentiles)):
        #ValPercentiles[k] = np.percentile(datos, Percentiles[k])
		ValPercentiles[k] = scoreatpercentile(datos, Percentiles[k])
    
    #print ValPercentiles

    LimInf = np.array(ValPercentiles[0:-1], dtype=float)
    LimSup = np.array(ValPercentiles[1:], dtype=float)
    #print LimInf, LimSup

    datosQ = np.array(datos, dtype=float) # Esta va a ser la senal codificada

    for k in range(0, len(LimInf)-1):
        #como en matlab
        if matlab == 1:
            datosQ[np.logical_and(datos>LimInf[k], datos<=LimSup[k])] = k
        #distinto
        else:
            datosQ[np.logical_and(datos>=LimInf[k], datos<LimSup[k])] = k

    if matlab == 1:
        datosQ[datos>LimInf[-1]] = AL-1
    else:
        datosQ[datos>=LimInf[-1]] = AL-1

    dstr = datosQ.astype(int).tolist().__str__()
    dstr = dstr.replace(",","")
    dstr = dstr.replace(" ","")
    dstr = dstr.replace("[","")
    dstr = dstr.replace("]","")
    
    rate = np.zeros(Dictionary.__len__())
    for k in range(0,dstr.__len__()-WL,(WL-OL)):
        word=dstr[k:k+WL]
        for l in range (0,Dictionary.__len__()):
            if Dictionary[l] == word :
                rate[l] += 1
    rate = rate/sum(rate)
    rate = np.round(rate,4)
    
    dr = []
    for i in range(Dictionary.__len__()):
        dr.append((Dictionary[i],rate[i]))
        
    out = {'dr': dr}
    return out