#encoding:utf-8

#Models
from app.models import file_data, file_header, file_channel, file_mask, session_data, session_channel_mask

#Sessions
from django.contrib.sessions.models import Session

#JSON
from django.utils import simplejson
#from django.core import serializers

#New program
from app.new_program.read_dat import read_file_dat as compute_read_file
from app.new_program.det_AD import det_AD as compute_AD
from app.new_program.general_def import apply_changes_general as changes_general
from app.new_program.general_def import decimate as apply_decimate
from app.new_program.statistical_analysis_def  import compute_statistic as compute_stat
from app.new_program.sleep_analysis_def import sleep_analysis_def as compute_sleep
from app.new_program.cosinor_def import EstimarCosinor as compute_cosinor
from app.new_program.symbolic_dynamic_def import DinSym as compute_DinSym
from app.new_program.ctm_def import ctm_fun as compute_ctm

#Classifier
from app.new_program.KNN.ctm_light import ctm_fun as class_ctm
from app.new_program.KNN.KNN_class import knn_class_run as class_knn

#cache
from django.core.cache import cache
from django.views.decorators.cache import never_cache

#csrf
from django.views.decorators.csrf import csrf_exempt

#numpy
from  numpy import fromstring, linspace

#settings
from django.conf import settings

#system
from sys import getrefcount
import os

#HTTP 
from django.http import HttpResponse, HttpResponseRedirect
from django.shortcuts import render_to_response, get_object_or_404
from django.template import RequestContext

# Used to log in and to log out
from django.contrib.auth.decorators import login_required

@never_cache
@login_required(login_url='/log_in')
def app(request):
	user = request.user
	current_session = session_data.objects.get(user_name=user)
	options = file_data.objects.filter(user_name=user)
	if current_session.file_dat:
		ID = current_session.file_dat.pk
		current_file_dat = file_data.objects.get(pk=ID)
		#channels available
		channels = []
		i = 0
		for p in str_to_list_str(current_file_dat.channels_name):
			channels = channels  + [(i,p)]
			i = i+1
		#minimun decimate
		epoch = str_to_list(current_file_dat.epoch_period)
		decim = epoch[0]*3600+epoch[1]*60+epoch[2]
		#activity-rest, start and end
		start_time = str_to_list(current_file_dat.start_time)
		start_time_s = start_time[0]*3600*24+start_time[1]*3600+start_time[2]*60+start_time[3]
		ar_s_s = str_to_list(current_file_dat.a_r_start)[0] + start_time_s
		ar_e_s = str_to_list(current_file_dat.a_r_end)[0] + start_time_s
		ar_start = s_to_dhms(ar_s_s)
		ar_end = s_to_dhms(ar_e_s)
		dict_web={'user':user,
				'select_channels':channels,
				'current_channel':int(current_session.channel),
				'decim':decim,
				'current_decim':current_session.decim,
				'start_time':start_time,
				'interval_end':str_to_list(current_file_dat.interval_end),
				'current_onset':str_to_list(current_session.onset),
				'current_end':str_to_list(current_session.end),
				'ar_start':ar_start,
				'ar_end':ar_end,
				'ID': ID,
				'options':options,}
	else:
		dict_web={'user':user,
				'options':options,
				'ID': -1,}
	return render_to_response('app/app.html', dict_web, context_instance=RequestContext(request))

#Load file
#Select file

"""@never_cache
@login_required(login_url='/log_in')
def select_file(request):
	user = request.user
	current_session = session_data.objects.get(user_name=user)
	'''ID=request.GET['ID']
	aux = file_data.objects.filter(user_name=user).get(pk=ID)
	b = data_file.objects.get(file_data=aux)
	#del b
	print getrefcount(b)
	print eval(b.channels_data)[0]'''
	out='failed'
	return HttpResponse(simplejson.dumps(out), mimetype='application/json')
"""

@never_cache
@login_required(login_url='/log_in')
def select_file(request):
	user = request.user
	current_session = session_data.objects.get(user_name=user)
	if request.method=='GET':
		try:
			ID=request.GET['ID']
		except:
			ID=-1
		if ID != -1:
			try:
				aux = file_data.objects.filter(user_name=user).get(pk=ID)
			except:
				aux = -1
			if aux != -1:
				current_session.file_dat = aux
				epoch = str_to_list(current_session.file_dat.epoch_period)
				min_decim = epoch[0]*3600+epoch[1]*60+epoch[2]
				if min_decim <= 60 :
					decim = 60
				else:
					decim = min_decim
				current_session.file_dat     = aux
				current_session.decim        = decim
				current_session.channel      = 0
				current_session.channel_name = aux.channels_name[0]
				current_session.onset        = aux.start_time
				current_session.end          = aux.interval_end
				current_session.save()
				e = session_channel_mask.objects.get(regarding=current_session)
				e.channel  = value_to_strDB(apply_decimate(str_to_list_float(file_channel.objects.filter(regarding=aux).get(number=0).channel),decim,1))
				e.mask = value_to_strDB(apply_decimate(str_to_list_float(file_mask.objects.get(regarding=current_session.file_dat).mask),decim,2))
				e.save()
				out='done'
			else:
				out='failed'
		else:
			out='failed'
	else:
		out='failed'
	return HttpResponse(simplejson.dumps(out), mimetype='application/json')
#Delete file
@never_cache
@login_required(login_url='/log_in')
def delete_file(request):
	user = request.user
	current_session = session_data.objects.get(user_name=user)
	if request.method=='GET':
		try:
			ID=request.GET['ID']
		except:
			ID=-1
		if ID != -1:
			try:
				aux = file_data.objects.filter(user_name=user).get(pk=ID)
			except:
				aux = -1
			if aux != -1:
				#delete
				a = aux
				b = file_header.objects.get(regarding=a)
				for i in range(a.n_channels):
					c = file_channel.objects.filter(regarding=a).get(number=i)
					c.delete()
				d = file_mask.objects.get(regarding=a)
				a.delete()
				b.delete()
				d.delete()
				try:
					current_file = current_session.file_dat
				except:
					current_file = -999
				#is the current file or other?
				if current_file == aux:
					current_session.file_dat = None
					current_session.channel = 0
					current_session.channel_name = ""
					current_session.decim  = 1
					current_session.onset  = ""
					current_session.end    = ""
					current_session.save()
					e = session_channel_mask.objects.get(regarding=aux)
					e.channel = ""
					e.mask = ""
					e.save()
				out='done'
			else:
				out='failed'
		else:
			out='failed'
	else:
		out='failed'
	return HttpResponse(simplejson.dumps(out), mimetype='application/json')
#File Upload
@never_cache
@login_required(login_url='/log_in')
@csrf_exempt
def upload_file(request):
	user = request.user
	current_session = session_data.objects.get(user_name=user)
	message = "Failed to upload file"
	#print request.POST
	#print request.FILES
	if request.method=='POST':
		try:
			f=request.FILES['file']
		except:
			f=-1
		if (f != -1) & (str(f) != ""):
			val = 1
			if f.size > 30*1024*1024:
				val = 0
				message = "File too large, it should be smaller 30MB"
			# extension .dat
			try:
				str(f.name).index('.dat')
			except:
				val = 0
				message = "Doesn't have proper extension"
			if len(str(f.name))> 40:
				val = 0
				message = "File name should be shorter than 40 char"
			#print f.size, f
			if val == 1:
				path = str(settings.MEDIA_ROOT+"/files_dat/"+str(user)+"_"+str(f.name))
				destination = open(path, 'wb+')
				for chunk in f.chunks():
					destination.write(chunk)
				destination.close()
				message = 'done'
				out={'path':path,
					'name':str(f.name),
					'success':message}
			else:
				out={'success':message}
		else:
			out={'success':message}
	else:
		out={'success':message}
	return HttpResponse(simplejson.dumps(out), mimetype='application/json')
#Process data
@never_cache
@login_required(login_url='/log_in')
def process_data(request):
	user = request.user
	current_session = session_data.objects.get(user_name=user)
	if request.method=='GET':
		try:
			f_name=request.GET['f_name']
		except:
			f_name=-1
		if (f_name != -1):
			name = request.GET['name']
			notes = request.GET['notes']
			path = request.GET['path']
			Output = compute_read_file(path)
			Activity_mask = compute_AD(Output['Channels_data'][0])
			a = file_data.objects.create(
						user_name        = request.user,
						file_name        = f_name,
						start_time       = value_to_strDB(Output['Start_time']),
						start_date       = value_to_strDB(Output['Start_date']),
						epoch_period     = value_to_strDB(Output['Epoch']),
						mode             = int(Output['Mode']),
						descriptive_name = name,
						notes            = notes,
						n_channels       = int(Output['N_channels']),
						channels_name    = value_to_strDB(Output['Channels_names']),
						total_t          = value_to_strDB(Output['Total_time']),
						data_per_channel = int(Output['Channels_data'][0].__len__()),
						a_r_start        = value_to_strDB(Activity_mask['A_R_Start']),
						a_r_end          = value_to_strDB(Activity_mask['A_R_End']),
						interval_end     = value_to_strDB(Output['End_time'])
						)
			b = file_header.objects.create(
						regarding   = a,
						header      = value_to_strDB(Output['Header']))
			for i in range(int(Output['N_channels'])):
				c = file_channel.objects.create(
						regarding   = a,
						number      = i,
						channel     = value_to_strDB(Output['Channels_data'][i]))
			d = file_mask.objects.create(
						regarding   = a,
						mask        = value_to_strDB(Activity_mask['Filter']))
			min_decim = Output['Epoch'][0]*3600+Output['Epoch'][1]*60+Output['Epoch'][2]
			if min_decim <= 60 :
				decim = 60
			else:
				decim = min_decim
			current_session.file_dat     = a
			current_session.decim        = decim
			current_session.channel      = 0
			current_session.channel_name = Output['Channels_names'][0]
			current_session.onset        = value_to_strDB(Output['Start_time'])
			current_session.end          = value_to_strDB(Output['End_time'])
			current_session.save()
			e = session_channel_mask.objects.get(regarding=current_session)
			e.channel  = value_to_strDB(apply_decimate(Output['Channels_data'][0],decim,1))
			e.mask = value_to_strDB(apply_decimate(Activity_mask['Filter'],decim,2))
			e.save()
			os.remove(path)
		out={'success':'done'}
	else:
		out={'success':'failed'}
	return HttpResponse(simplejson.dumps(out), mimetype='application/json')

#Show register
@never_cache
@login_required(login_url='/log_in')
def register_graphic(request):
	user = request.user
	current_session = session_data.objects.get(user_name=user)
	if current_session.file_dat:
		a = session_channel_mask.objects.get(regarding=current_session)
		dict_web={'user':user,
				'channel_name':current_session.channel_name,
				'decim':current_session.decim,
				'current_onset': str_to_list(current_session.onset),
				'current_end':str_to_list(current_session.end),
				'start_date':str_to_list(current_session.file_dat.start_date),
				'data':str_to_list_float(a.channel),
				'mask':str_to_list_float(a.mask),
				'name':current_session.file_dat.descriptive_name,
				'var':0}
	else:
		dict_web={'user':user,
				'var':1}
	return render_to_response('app/graphics/register_graphic.html', dict_web, context_instance=RequestContext(request))

#show info
@never_cache
@login_required(login_url='/log_in')
def show_info(request):
	user = request.user
	current_session = session_data.objects.get(user_name=user)
	if current_session.file_dat:
		dict_web={'user':user,
				'name':current_session.file_dat.descriptive_name,
				'notes':current_session.file_dat.notes,
				'var':0}
	else:
		dict_web={'user':user,
				'var':1}
	return render_to_response('app/show_info.html', dict_web, context_instance=RequestContext(request))
#edit info
@never_cache
@login_required(login_url='/log_in')
def edit_info(request):
	user = request.user
	current_session = session_data.objects.get(user_name=user)
	if current_session.file_dat:
		if request.method=='GET':
			try:
				name=request.GET['name']
			except:
				name=-1
			if name != -1:
				notes = request.GET['notes']
				file_data.objects.filter(pk=current_session.file_dat.pk).update(descriptive_name=name, notes=notes)
				current_session = session_data.objects.get(pk=current_session.pk)
				out='done'
			else:
				out='failed'
		else:
			out='failed'
	else:
		out='failed'
	return HttpResponse(simplejson.dumps(out), mimetype='application/json')


#GENERAL
@never_cache
@login_required(login_url='/log_in')
def set_general(request):
	user = request.user
	current_session = session_data.objects.get(user_name=user)
	if current_session.file_dat:
		recalculate_ad = int(request.GET['recalculate_ad'])
		channel_id = int(request.GET['channel'])
		start_time = str_to_list(current_session.file_dat.start_time)
		decimate = int(request.GET['decimate'])
		interval_onset = str_to_list(request.GET['interval_onset'])
		interval_end = str_to_list(request.GET['interval_end'])
		channel = str_to_list_float(file_channel.objects.filter(regarding=current_session.file_dat).get(number=channel_id).channel)
		mask = str_to_list_float(file_mask.objects.get(regarding=current_session.file_dat).mask)
		current_data, current_mask = changes_general(decimate, interval_onset, interval_end, start_time, recalculate_ad, channel, mask)
		current_session.channel = channel_id
		current_session.decim = decimate
		current_session.channel_name = str_to_list_str(current_session.file_dat.channels_name)[channel_id]
		current_session.onset = value_to_strDB(interval_onset)
		current_session.end   = value_to_strDB(interval_end)
		current_session.save()
		e = session_channel_mask.objects.get(regarding=current_session)
		e.channel  = value_to_strDB(current_data)
		e.mask = value_to_strDB(current_mask)
		e.save()
		out='done'
	else:
		out='failed'
	return HttpResponse(simplejson.dumps(out), mimetype='application/json')

#STATISTICAL ANALYSIS
@never_cache
@login_required(login_url='/log_in')
def stat_graphic(request):
	user = request.user
	current_session = session_data.objects.get(user_name=user)
	if current_session.file_dat:
		if request.method=='GET':
			try:
				frame=request.GET['frame']
			except:
				frame=-1
			if frame != -1:
				frame = int(request.GET['frame'])
				nbin = int(request.GET['nbin'])
				#print frame, nbin
				e = session_channel_mask.objects.get(regarding=current_session)
				out = compute_stat(str_to_list_float(e.channel),str_to_list_float(e.mask),frame,nbin)
				dict_web={'user':user,
				'out':out,
				'var':0}
			else:
				dict_web={'user':user,
				'var':1}
	else:
		dict_web={'user':user,
				'var':2}
	return render_to_response('app/graphics/stat_graphic.html', dict_web, context_instance=RequestContext(request))

#SLEEP ANALYSIS
@never_cache
@login_required(login_url='/log_in')
def sleep_graphic(request):
	user = request.user
	current_session = session_data.objects.get(user_name=user)
	if current_session.file_dat:
		if request.method=='GET':
			try:
				frame=request.GET['t1']
			except:
				frame=-1
			if frame != -1:
				#leer y pasar los datos
				t1 = str_to_list(request.GET['t1'])
				t2 = str_to_list(request.GET['t2'])
				start_time = str_to_list(current_session.file_dat.start_time)
				s0 = start_time[0]*3600*24+start_time[1]*3600+start_time[2]*60+start_time[3]
				s1 = t1[0]*3600*24+t1[1]*3600+t1[2]*60+t1[3] - s0
				s2 = t2[0]*3600*24+t2[1]*3600+t2[2]*60+t2[3] - s0
				b = file_channel.objects.filter(regarding=current_session.file_dat).get(number=current_session.channel)
				channel = str_to_list_float(b.channel)
				out = compute_sleep(channel[s1:s2])
				#print frame, nbin
				#out = compute_stat(current_session.current_data,current_session.activity_mask,frame,nbin)
				dict_web={'user':user,
				'out':out,
				'var':0}
			else:
				dict_web={'user':user,
				'var':1}
	else:
		dict_web={'user':user,
				'var':2}
	return render_to_response('app/graphics/sleep_graphic.html', dict_web, context_instance=RequestContext(request))

#COSINOR ANALYSIS
@never_cache
@login_required(login_url='/log_in')
def cosinor_graphic(request):
	user = request.user
	current_session = session_data.objects.get(user_name=user)
	if current_session.file_dat:
		if request.method=='GET':
			try:
				alpha = float(request.GET['alpha'])
			except:
				alpha = -1
			if alpha != -1:
				rhythm = str_to_list(request.GET['rhythm'])
				alpha = alpha/100.
				interval_onset = str_to_list(current_session.onset)
				interval_end = str_to_list(current_session.end)
				r = float(rhythm[0]*24*3600+rhythm[1]*3600+rhythm[2]*60+rhythm[3])/24./60./60.
				onset = float(interval_onset[0]*3600*24+interval_onset[1]*3600+interval_onset[2]*60+interval_onset[3])/24./60./60.
				end = float(interval_end[0]*3600*24+interval_end[1]*3600+interval_end[2]*60+interval_end[3])/24./60./60.
				e = session_channel_mask.objects.get(regarding=current_session)
				current_data = str_to_list_float(e.channel)
				tC = linspace(onset,end,current_data.__len__())
				out = compute_cosinor(current_data, tC, r, alpha)
				#print frame, nbin
				#out = compute_stat(current_session.current_data,current_session.activity_mask,frame,nbin)
				decim = current_session.decim
				dict_web={'user':user,
					'out':out,
					'data':current_data,
					'decim':decim,
					'start_date':str_to_list(current_session.file_dat.start_time),
					'current_onset':str_to_list(current_session.onset),
					'var':0}
			else:
				dict_web={'user':user,
				'var':1}
	else:
		dict_web={'user':user,
				'var':2}
	return render_to_response('app/graphics/cosinor_graphic.html', dict_web, context_instance=RequestContext(request))

#SYMBOLIC ANALYSIS
@never_cache
@login_required(login_url='/log_in')
def symbol_graphic(request):
	user = request.user
	current_session = session_data.objects.get(user_name=user)
	if current_session.file_dat:
		if request.method=='GET':
			try:
				frame= int(request.GET['frame'])
			except:
				frame=-1
			if frame != -1:
				AL = int(request.GET['alphabet'])
				WL = int(request.GET['symbols'])
				OL = int(request.GET['overlaping'])
				matlab = 1
				e = session_channel_mask.objects.get(regarding=current_session)
				channel = str_to_list_float(e.channel)
				mask    = str_to_list_float(e.mask)
				out = compute_DinSym(channel,mask,frame, AL, WL, OL, matlab)
				dict_web={'user':user,
					'out':out,
					'var':0}
			else:
				dict_web={'user':user,
				'var':1}
	else:
		dict_web={'user':user,
				'var':2}
	return render_to_response('app/graphics/symbol_graphic.html', dict_web, context_instance=RequestContext(request))

#CTM
@never_cache
@login_required(login_url='/log_in')
def ctm_graphic(request):
	user = request.user
	current_session = session_data.objects.get(user_name=user)
	if current_session.file_dat:
		if request.method=='GET':
			try:
				frame= int(request.GET['frame'])
			except:
				frame=-1
			if frame != -1:
				rho = int(request.GET['rho'])
				e = session_channel_mask.objects.get(regarding=current_session)
				channel = str_to_list_float(e.channel)
				mask    = str_to_list_float(e.mask)
				out = compute_ctm(channel, mask,frame, rho)
				dict_web={'user':user,
					'out':out,
					'var':0}
			else:
				dict_web={'user':user,
				'var':1}
	else:
		dict_web={'user':user,
				'var':2}
	return render_to_response('app/graphics/ctm_graphic.html', dict_web, context_instance=RequestContext(request))

#CLASSIFIER
@never_cache
@login_required(login_url='/log_in')
def classifier_graphic(request):
	user = request.user
	current_session = session_data.objects.get(user_name=user)
	if current_session.file_dat:
		if request.method=='GET':
			try:
				c_type = int(request.GET['c_type'])
			except:
				c_type = -1
			if c_type == 1:
				names = str_to_list_str(current_session.file_dat.channels_name)
				try:
					ind_z = int(names.index(' z Axis'))
				except:
					ind_z = -1
				try:
					ind_r = int(names.index(' Vector Module'))
				except:
					ind_r = -1
				if (ind_r == -1 | ind_z == -1):
					dict_web={'user':user,
					    'out':"z Axis and Vector Module are necessary",
					    'var':2}
					render_to_response('app/graphics/knn_graphic.html', dict_web, context_instance=RequestContext(request))
				else:
					k = int(request.GET['k'])
					t1 = str_to_list(request.GET['t1'])
					t2 = str_to_list(request.GET['t2'])
					start_time = str_to_list(current_session.file_dat.start_time)
					channel = str_to_list_float(file_channel.objects.filter(regarding=current_session.file_dat).get(number=ind_z).channel)
					mask = str_to_list_float(file_mask.objects.get(regarding=current_session.file_dat).mask)
					c1_data, c1_mask = changes_general(1, t1, t2, start_time, 0, channel, mask)
					c1 = class_ctm(c1_data, c1_mask,3, 45)['CTM']
					channel = str_to_list_float(file_channel.objects.filter(regarding=current_session.file_dat).get(number=ind_r).channel)
					c2_data, c2_mask = changes_general(30, t1, t2, start_time, 0, channel, mask)
					c2 = class_ctm(c2_data, c2_mask,1, 22)['CTM']
					p = [c1,c2]
					out = class_knn(p,k)
					dict_web={'user':user,
						'out':out,
						'var':0}
					render_to_response('app/graphics/knn_graphic.html', dict_web, context_instance=RequestContext(request))
			else:
				dict_web={'user':user,
				'var':1}
	else:
		dict_web={'user':user,
				'var':2}
	return render_to_response('app/graphics/knn_graphic.html', dict_web, context_instance=RequestContext(request))


#OTHER FUNCTIONS

#seconds to [dd,hh,mm,ss]
def s_to_dhms (s):
	#s -> seconds
	time = [0,0,0,0]
	time[3] = int(s%60) #seconds
	mins = int(s/60)
	time[2] = int(mins%60)
	h = int(mins/60)
	time[1] = int(h%24)
	time[0] = int(h/24)
	return time

#For read lis from DB
def str_to_list(string):
	out = fromstring(string,dtype=int, sep=',')
	return out.tolist()

def str_to_list_float(string):
	out = fromstring(string,dtype=float, sep=',')
	return out.tolist()

def str_to_list_str(string):
	aux = ''
	out = []
	for i in range(len(string)):
		if string[i] == ',':
			out.append(aux)
			aux = ''
		elif i == len(string)-1:
			aux = aux + string[i]
			out.append(aux) 
		else:
			aux = aux + string[i]
	return out

#For save a list to DB
def value_to_strDB(value):
	value = str(value)
	try:
		value = value.replace("'","")
	except:
		pass
	try:
		value = value.replace('"','')
	except:
		pass
	'''try:
		value = value.replace(" ","")
	except:
		pass'''
	try:
		value = value.replace("[","")
	except:
		pass
	try:
		value = value.replace("]","")
	except:
		pass
	return value
