# -*- coding: utf-8 -*-
"""
Created on Mon May 19 10:30:16 2014

@author: dani
"""
import numpy
from numpy import dot, mean, real
from numpy import sum as summ
import sympy
import math
import scipy
#from scipy.stats import t

"""
		 CIcalc 
"""
def CIcalc(X,T,Z,beta,gamma,n,sigma,Amp,phi,alpha):
	#Find beta and gamma confidence region
	F_distr = scipy.stats.f.ppf(1-alpha,2,n-3)

	A = X
	B = dot(2,T)
	C = Z
	D = dot(-2,dot(X,beta)) + dot(-2,dot(T,gamma))
	E = dot(-2,dot(T,beta)) + dot(-2,dot(Z,gamma))
	F = dot(X,numpy.power(beta,2)) + dot(2,dot(T,dot(beta,gamma))) + dot(Z,numpy.power(gamma,2)) - dot(numpy.power(sigma,2),F_distr)/float(n)
	
	g_max = -(2*A*E - D*B)/(4*A*C - B**2)
	
	ul = g_max+Amp*2 #upperlimit
	ll = g_max-Amp*2 #lowerlimit
	step = Amp/1000

	gamma_s = map(lambda x: ll+x*step, range(int((ul-ll)/step)+1))
	gamma_s = numpy.asarray(gamma_s)
	
	auxBD = (dot(B,gamma_s)+D).astype('complex')
	auxBD2 = numpy.power(auxBD,2)
	auxC = (dot(C, numpy.power(gamma_s,2))).astype('complex')
	auxEF = (dot(E,gamma_s)+F).astype('complex')
	beta_s1 = (-auxBD+numpy.power((auxBD2-dot(complex(dot(4,A)),(auxC+auxEF))),0.5))/(float(2*A))
	beta_s2 = (-auxBD-numpy.power((auxBD2-dot(complex(dot(4,A)),(auxC+auxEF))),0.5))/(float(2*A))
	
	
	#Isolate ellipse region
	#IND = ((real(beta_s1)-real(beta_s2))< 0.0001) & ((real(beta_s1)-real(beta_s2))> -0.0001)
	IND = numpy.round(real(beta_s1),5) != numpy.round(real(beta_s2),5)

	#IND = IND == 0
	
	gamma_s = gamma_s[IND]
	beta_s1 = beta_s1[IND]
	beta_s2 = beta_s2[IND]
	
	#%Determine if confidence region overlaps the pole.

	#%Confidence Intervals for Amplitude
	
	CI_Amp_max1 = numpy.max(numpy.power(numpy.power(beta_s1,2) + numpy.power(gamma_s,2),0.5))
	CI_Amp_max2 = numpy.max(numpy.power(numpy.power(beta_s2,2) + numpy.power(gamma_s,2),0.5))
	CI_Amp_max = numpy.maximum(CI_Amp_max1,CI_Amp_max2)
	
	CI_Amp_min1 = numpy.min(numpy.power(numpy.power(beta_s1,2) + numpy.power(gamma_s,2),0.5))
	CI_Amp_min2 = numpy.min(numpy.power(numpy.power(beta_s2,2) + numpy.power(gamma_s,2),0.5))
	CI_Amp_min = numpy.minimum(CI_Amp_min1,CI_Amp_min2)
	
	#%Confidence Intervals for Acrophase
	aux1 = numpy.absolute(numpy.divide(gamma_s,beta_s1))
	aux1 = numpy.arctan(aux1.astype('float'))
	aux2 = numpy.arctan(numpy.absolute(numpy.divide(gamma_s,beta_s2)).astype('float'))
	theta = numpy.concatenate((aux1,aux2))
	a = numpy.sign(real(numpy.concatenate((beta_s1,beta_s2))))
	b = dot(numpy.sign(real(numpy.concatenate((gamma_s,gamma_s)))),3.)
	c = a + b
	CIphi = numpy.zeros(c.__len__())
	for ii in range(c.__len__()):
		if (c[ii] == 4. or c[ii] == 3.):
			CIphi[ii] = -theta[ii]
			c[ii] = 1.
		elif (c[ii] == 2. or c[ii] == -1. ): 
			CIphi[ii] = -numpy.pi + theta[ii]
			c[ii] = 2.
		elif (c[ii] == -4. or c[ii] == -3.):
			CIphi[ii] = -numpy.pi - theta[ii]
			c[ii] = 3.
		elif (c[ii] == -2. or c[ii] == 1.):
			CIphi[ii] = -2.*numpy.pi + theta[ii]
			c[ii] = 4.
	if numpy.max(c) - numpy.min(c) == 3.:
		CI_phi_max = numpy.min(CIphi[c == 1]);
		CI_phi_min = numpy.max(CIphi[c == 4]);
	else:
		CI_phi_max = numpy.max(CIphi);
		CI_phi_min = numpy.min(CIphi);

	CIs = [CI_Amp_min, CI_Amp_max, CI_phi_min, CI_phi_max]
	Elipse = numpy.concatenate((real(gamma_s),real(beta_s1),real(beta_s2))).reshape(3,gamma_s.__len__())
	
	out = {'CI': CIs,
		'Elipse':Elipse}

	return out


"""
		 cosinor
"""
def cosinor(t,y,w,alpha):
	## I. Parameter Estimation
	n = t.__len__()

	x = numpy.array(numpy.cos(dot(w,t)),dtype=float)
	z = numpy.array(numpy.sin(dot(w,t)),dtype=float)

	# Set up and solve the normal equations simultaneously
	NE = numpy.array([n, summ(x), summ(z), summ(y),
				 summ(x), summ(numpy.power(x,2.)), summ(dot(x,z)), summ(dot(x,y)),
				 summ(z), summ(dot(x,z)),summ(numpy.power(z,2.)), summ(dot(z,y))],dtype=float).reshape((3,4)) 
	RNE, pivots = sympy.Matrix(NE).rref()
	M = RNE[0,3]
	beta = RNE[1,3]
	gamma = RNE[2,3]
	
	# Calculate amplitude and acrophase from beta and gamma
	aux = float(numpy.power(beta,2.) + numpy.power(gamma,2.))
	Amp = numpy.power(aux,0.5)
	theta = math.atan(abs(gamma/beta))
	
	# Calculate acrophase (phi) and convert from radians to degrees
	a = numpy.sign(beta)
	b = numpy.sign(gamma)
	if ((a == 1 or a == 0) and b == 1):
		phi = -theta
	elif (a == -1 and (b == 1 or b == 0)): 
		phi = -numpy.pi + theta
	elif ((a == -1 or a == 0) and b == -1):
		phi = -numpy.pi - theta
	elif (a == 1 and (b == -1 or b == 0)):
		phi = -2*numpy.pi + theta
	
	f = M + dot(Amp,numpy.cos(dot(w,t)+phi))
	
	# II. Confidence Limtes for Single Cosinor
	#Residual sum of errors
	RSS = summ(numpy.power(y - (M + dot(beta,x) + dot(gamma,z)),2))
	
	# Residual varience estimation
	sigma = numpy.power(RSS/(n-3),0.5)
	
	#Find confidence interval for mesor
	X = summ(numpy.power(x-mean(x),2))/n
	Z = summ(numpy.power(z-mean(z),2))/n
	T = summ(dot(x -mean(x),z-mean(z)))/n
	
	#Confidence interval for the mesor
	aux1 = scipy.stats.t.ppf(1-alpha/2,n-3) #tinv(1-alpha/2,n-3)
	aux2 = numpy.power(sigma,2) #sigma^2
	aux3 = dot(summ(numpy.power(x,2)),summ(numpy.power(z,2)))-summ(numpy.power(dot(x,z),2))  #((sum(x.^2))*(sum(z.^2)) - (sum(x.*z))^2)
	aux4 = dot(numpy.power(n,3),(dot(X,Z)-numpy.power(T,2)))#(n^3*(X*Z - T^2))
	CI_M = dot(dot(aux1,aux2),numpy.power(aux3/aux4,0.5))
	#CI_M = tinv(1-alpha/2,n-3)*sigma^2*sqrt(((sum(x.^2))*(sum(z.^2)) - (sum(x.*z))^2)/(n^3*(X*Z - T^2)));
	
	#Find confidence intervals for the amplitude and acrophase

	RRR = CIcalc(X,T,Z,beta,gamma,n,sigma,Amp,phi,alpha);

	# III. Zero-amplitude test
	auxp1 = dot(n,(dot(X,numpy.power(beta,2.))+dot(2.,dot(T,dot(beta,gamma)))+dot(Z,numpy.power(gamma,2.))))
	auxp2 = dot(2.,numpy.power(sigma,2.))
	p_3a = scipy.stats.f.pdf(float(auxp1/auxp2),2,n-3)
	
	"""
	out = {'M':M,
		'A':Amp,
		'Phi':phi,
		'CI_M':CI_M,
		'CI_A':RRR['CI'][0:2],
		'CI_Phi':RRR['CI'][2::],
		'Elipse':RRR['Elipse'].tolist(),
		'pvalor':p_3a,
		'Senal':f.tolist(),
		'Acrophase':[phi/(2.*numpy.pi)*24, RRR['CI'][2]/(2.*numpy.pi)*24, RRR['CI'][3]/(2.*numpy.pi)*24]}
	"""
	#print 'mesor', cosinor_data['M'], '0',cosinor_data['CI_M']
	#print 'Amplitude', cosinor_data['A'], cosinor_data['CI_A'][0], cosinor_data['CI_A'][1]
	#print 'Acrophase', cosinor_data['Acrophase'][0], cosinor_data['Acrophase'][1], cosinor_data['Acrophase'][2]
	#print 'p-value', cosinor_data['pvalor'], '0', '0'
	out = {'M':M,
		'CI_M':CI_M,
		'A':Amp,
		'CI_A':RRR['CI'][0:2],
		'Acrophase':[phi/(2.*numpy.pi)*24, RRR['CI'][2]/(2.*numpy.pi)*24, RRR['CI'][3]/(2.*numpy.pi)*24],
		'pvalor':p_3a}
	return out

def EstimarCosinor(y, t, T, alpha):
	w = 2.*numpy.pi/float(T)
	y = numpy.array(y,dtype=float)
	t = numpy.array(t,dtype=float)
	Resultado = cosinor(t,y,w,alpha)
	return Resultado