# -*- coding: utf-8 -*-
"""
Created on Fri May 2 ‏‎12:38:24 2014

@author: Daniel Treceño

General

It chooses a channel, takes a interval of the data and applys a decimate.   
"""
from download_results.program.det_AD import det_AD as compute_AD
import numpy

#aplica los cambios
def apply_changes_general(epoch, t1, t2, start_time, recalculate_ad, channel, mask):
	'''
	epoch - decimate (int)
	t1 - interval_onset [dd,hh,mm,ss]
	t2 - interval_end [dd,hh,mm,ss]
	start_time - start_time [dd,hh,mm,ss]
	channel - current channel [...]
	mask - mask activity_rest [...]
	'''
	#aplica el intervalo
	s0 = start_time[0]*3600*24+start_time[1]*3600+start_time[2]*60+start_time[3]
	s1 = t1[0]*3600*24+t1[1]*3600+t1[2]*60+t1[3] - s0
	s2 = t2[0]*3600*24+t2[1]*3600+t2[2]*60+t2[3] - s0

	#choose interval
	channel = channel[s1:s2]
	if recalculate_ad == 1:
		out = compute_AD(channel)
		mask = out['Filter']
	else:
		mask = mask[s1:s2]

	#aplica el diezmado
	current_data = decimate(channel,epoch,1)
	activity_mask = decimate(mask,epoch,2)
	return current_data, activity_mask



"""
def decimate
------------
It applies the decimate to the channel.

Input:
------
channel -> unidimensional channel
factor -> decimate rate
typeFrame -> 1 is a channel, 2 is the mask of activity-rest

Output:
-------
out -> decimated channel

Algorithm:
----------
"""
def decimate(channel,factor,typeFrame):
	if factor == 1:
		return channel
	else:
		if typeFrame == 1:
			channel_np = numpy.asarray(channel,dtype=float)
			H = numpy.ones(factor,dtype=float)/factor
			S = numpy.convolve(channel_np,H,mode='same')
			out = S[0::factor]
			out = out.tolist()
			return out
		elif typeFrame ==2:
			s = numpy.asarray(channel,dtype=float)
			out = s[0::factor]
			out = out.tolist()
			return out
		else:
			return channel
		

