# -*- coding: utf-8 -*-
"""
Created on Wed May  7 12:08:18 2014

@author: dani
name: Statistical_Analysis.py
"""

import numpy
from scipy.stats import skew, kurtosis, scoreatpercentile


"""
Tengo que calcular:
->media: mean
->mediana: median
->desviación estandar: Standard deviation
->rango intercuartil:  IQR
->sesgo: skewness
->Kurtosis
->coeficiente de variación: variantion coefficient (std/mean)

"""

def compute_statistic(channel,mask,frame):
	channel = numpy.asarray(channel,dtype=float)
	mask = numpy.asarray(mask,dtype=float)
	mask = mask.astype(bool)
	
	if frame == 1: #actividad
		data = channel[mask]
	elif frame == 2: #descanso
		data = channel[mask==0]
	elif frame == 3: #completo
		data = channel
	else:
		#data = channel
		return -1

	mean = numpy.mean(data)
	median = numpy.median(data)
	std = numpy.std(data)

	#upperQuartile = numpy.percentile(data,75)
	#lowerQuartile = numpy.percentile(data,25)
	upperQuartile = scoreatpercentile(data,75)
	lowerQuartile = scoreatpercentile(data,25)
	IQR = upperQuartile - lowerQuartile
	
	skewness = skew(data)
	curtosis = kurtosis(data,axis=0, fisher=0)
	vc = std/mean

	
	out = {'mean':mean,
		   'median':median,
		   'std':std,
		   'iqr':IQR,
		   'skew':skewness,
		   'kurtosis':curtosis,
		   'vc':vc}    
	return out    